# -*- coding: utf-8 -*-

"""
   wegene.Controllers.SportController

   This file was automatically generated by APIMATIC BETA v2.0 on 02/22/2016
"""
import unirest

from wegene.APIHelper import APIHelper
from wegene.Configuration import Configuration
from wegene.APIException import APIException
from wegene.Models.SportAdvice import SportAdvice


class Sport(object):


    """A Controller to access Endpoints in the WeGeneAPILib API."""

    def get_advice(self,
                      profile_id,
                      sex,
                      age,
                      height,
                      weight,
                      health_target):
        """Does a POST request to /sport/advise/{profile_id}.

        Sports advice based on genetic and individual information

        Args:
            age (int): Age of the user
            health_target (string): Target for sport, only supporting slimming
                now
            height (int): Height of the user
            profile_id (string): Genetic profile Id
            sex (string): Sex of the user
            weight (int): Weight of the user

        Returns:
            SportAdvice: Response from the API.

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """
        # The base uri for api requests
        query_builder = Configuration.BASE_URI

        # Prepare query string for API call
        query_builder += "/sport/advise/{profile_id}"

        # Process optional template parameters
        query_builder = APIHelper.append_url_with_template_parameters(query_builder, {
            "profile_id": profile_id
        })

        # Validate and preprocess url
        query_url = APIHelper.clean_url(query_builder)

        # Prepare headers
        headers = {

            "Authorization": "Bearer "+ Configuration.o_auth_access_token,
            "user-agent": "APIMATIC 2.0",
            "accept": "application/json",

        }

        # Prepare parameters
        parameters = {
            "age": age,
            "health_target": health_target,
            "height": height,
            "sex": sex,
            "weight": weight
        }

        # Prepare and invoke the API call request to fetch the response
        response = unirest.post(query_url, headers=headers, params=parameters)

        # Error handling using HTTP status codes
        if response.code < 200 or response.code > 206:  # 200 = HTTP OK
            raise APIException("HTTP Response Not OK", response.code, response.body)

        # Try to cast response to desired type
        if isinstance(response.body, dict):
            # Response is already in a dictionary, return the object
            try:
                return SportAdvice(**response.body)
            except TypeError:
                raise APIException("Invalid JSON returned", response.code, response.body)

        # If we got here then an error occured while trying to parse the response
        raise APIException("Invalid JSON returned", response.code, response.body)
