# -*- coding: utf-8 -*-

"""
   wegene.Models.Demographic

   This file was automatically generated by APIMATIC BETA v2.0 on 02/22/2016
"""
from wegene.APIHelper import APIHelper


class Demographic(object):

    """Implementation of the 'demographic' model.

    Report for user demographic

    Attributes:
        surname (string): Self-reported surname of the user
        population (string): Self-reported population of the user
        native_province (string): Self-reported native province of the user
        native_city (string): Self-reported native city of the user

    """

    def __init__(self,
                 **kwargs):
        """Constructor for the Report class

        Args:
            **kwargs: Keyword Arguments in order to initialise the
                object. Any of the attributes in this object are able to
                be set through the **kwargs of the constructor. The values
                that can be supplied and their types are as follows::

                    surname -- string -- Self-reported surname of the user
                    population -- string -- Self-reported population of the user
                    native_province -- string -- Self-reported native province of the user
                    native_city -- string -- Self-reported native city of the user

        """
        # Set all of the parameters to their default values
        self.surname = None
        self.population = None
        self.native_province = None
        self.native_city = None

        # Create a mapping from API property names to Model property names
        replace_names = {
            "surname": "surname",
            "population": "population",
            "native_province": "native_province",
            "native_city": "native_city",
        }

        # Parse all of the Key-Value arguments
        if kwargs is not None:
            for key in kwargs:
                # Only add arguments that are actually part of this object
                if key in replace_names:
                    setattr(self, replace_names[key], kwargs[key])

    def resolve_names(self):
        """Creates a dictionary representation of this object.

        This method converts an object to a dictionary that represents the
        format that the model should be in when passed into an API Request.
        Because of this, the generated dictionary may have different
        property names to that of the model itself.

        Returns:
            dict: The dictionary representing the object.

        """
        # Create a mapping from Model property names to API property names
        replace_names = {
            "surname": "surname",
            "population": "population",
            "native_province": "native_province",
            "native_city": "native_city",
        }

        retval = dict()

        return APIHelper.resolve_names(self, replace_names, retval)
